#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#------------------------------------------------------------------------------------------------
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#------------------------------------------------------------------------------------------------
# IT WAS CREATED AND TESTED IN A WINDOWS ENVIRONMENT ONLY AND MAY NOT FUNCTION ON A MAC.
#------------------------------------------------------------------------------------------------
# THIS PLUGIN IS ANOTHER FIGMENT OF MY IMAGENATION AND IS NOT BASED ON OR COMPLY WITH ANYTHING! 
#------------------------------------------------------------------------------------------------
#    Name:	Remove Vertex
#      By:	sdmitch
#   Usage:	Remove an existing vertex from a curve or between two edges.
#		 Note:	
#			
#    Date:	Feb 2013
#------------------------------------------------------------------------------------------------
#
require 'Sketchup'
# ------------------  MENU SETUP ---------------------- #
unless $sdm_tools_menu
	$sdm_tools_menu = UI.menu("Plugins").add_submenu("Werkzeuge von sdmitch")
	$sdm_Edge_tools = $sdm_tools_menu.add_submenu("Kanten und Linien")
	$sdm_Face_tools = $sdm_tools_menu.add_submenu("Flächen Werkzeuge")
	$sdm_CorG_tools = $sdm_tools_menu.add_submenu("Gruppen und Komponenten")
	$sdm_Misc_tools = $sdm_tools_menu.add_submenu("Diverse Werkzeuge")
end
unless file_loaded?(__FILE__)
	$sdm_Edge_tools.add_item("Knotenpunkt Entfernen") { Sketchup.active_model.select_tool SDM::Remove_Vertex.new }
	file_loaded(__FILE__)
end
# ------------------------------------------------------ #
module SDM

	class Remove_Vertex

		def initialize
			@mod=Sketchup.active_model
			@ent=@mod.active_entities
			@sel=@mod.selection
			@vue=@mod.active_view
			@ip=Sketchup::InputPoint.new
			self.reset
		end
		
		def reset
			@status = 0
			@status_text = "Select the Curve or Edges to remove vertex from"
		end
		
		def onMouseMove(flags, x, y, view)
			@ip.pick view,x,y; view.tooltip = @ip.tooltip; view.refresh
			Sketchup::set_status_text @status_text
		end
		
		def onLButtonDown(flags, x, y, view)
			ph = view.pick_helper; ph.do_pick x,y; best=ph.best_picked
			if @status==0 && best.class==Sketchup::Edge
				if best.curve
					@edges=best.curve.edges; @is_curve=true
				else
					@edges=best.all_connected.grep(Sketchup::Edge); @is_curve=false
				end
				@edges.length<2 ? UI.beep : (@status=1; @status_text = "Pick the Vertex to Remove")
			elsif @status==1
				if @is_curve
					verts=@edges[0].curve.vertices
				else
					verts=[]; @edges.each{|e| verts<<e.vertices}
					verts.flatten!; verts.uniq!
				end
				pt=@ip.position; vhsh={}; verts.each{|v| vhsh[v]=pt.distance(v.position)}
				vt=vhsh.sort{|a,b| a[1]<=>b[1]}.map{|n| n[0]}[0];verts.delete(vt)
				@mod.start_operation "Remove Vertex"
				if @is_curve
					pts=verts.collect{|v| v.position}
					@ent.erase_entities(@edges)
					@edges=@ent.add_curve(pts)
				else
					edges=vt.edges;pts=[]; 
					edges.each{|e| pts<<e.other_vertex(vt).position}
					@ent.erase_entities(edges)
					edge=@ent.add_line(pts)
					@edges=edge.all_connected.grep(Sketchup::Edge)
				end
				@mod.commit_operation
				self.reset if @edges.length==1
			end
		end
		
		def onRButtonDown(flags, x, y, view)
			@status==0 ? onCancel(flags,view) : self.reset
		end
		
		def onCancel(flags,view)
			Sketchup.send_action "selectSelectionTool:"
		end
		 
		def draw(view)
			if( @ip.valid? && @ip.display? )
				@ip.draw(view)
			end
		
			if @status==0 && @ip.edge
				view.line_width=3
				view.drawing_color='blue'
				if @ip.edge.curve
					view.draw_polyline(@ip.edge.curve.vertices.collect{|v| v.position})
				else
					@ip.edge.all_connected.grep(Sketchup::Edge).each{|e| view.draw_line(e.start.position,e.end.position)}
				end
			end
		end
		
	end
	
end
